// RW Bumpmaster Project
// =====================
// Imageboard downloader + archiver demo;  SAVE.EVERYTHING.ANON. :^)

// Filename: ./main_bumpmaster.cpp
// -The program's entry point

#include "incls_all.hpp"

void diag_bumpmaster(Bumpmaster const& bump);
void diag_bumpmaster_slaves(Bumpmaster const& bump);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\nSAVE.EVERYTHING.ANON. :^)\n");

  // TEST: TEMP: Basic test of a Bumpmaster<->Dolldrop 'pull drop' uri request
  Bumpmaster bump{"bumpmaster"};
  bump.dolldrop().pull_w_hdr(bump.t(), "example.com");

  puts("\n...leaving main()\n");

} catch (runtime_error const& e) {
  if (use_stamps)
    analyze_callgraph();
  cerr << "\n\n" << e.what() << "\n\n";

} catch (exception const& e) {
  if (use_stamps)
    analyze_callgraph();
  cerr << "\n\n" << e.what() << "\n\n";

} catch (...) {
  if (use_stamps)
    analyze_callgraph();
  cerr << "\n\n Caught unknown error in main() \n\n";
}

//------------------------------------------------------------------------------
/**
 */
void diag_bumpmaster(Bumpmaster const& bump) {
  puts("");

  prt_tag(bump.t());
  prt_tag(bump.board().t(), "bump.board()");
  prt_tag(bump.catalog().t(), "bump.catalog()");
  prt_tag(bump.page().t(), "bump.page()");
  prt_tag(bump.post().t(), "bump.post()");
  prt_tag(bump.site().t(), "bump.site()");
  prt_tag(bump.thread().t(), "bump.thread()");
  prt_tag(bump.waifusearch().t(), "bump.waifusearch()");
  prt_tag(bump.dolldrop().t(), "bump.dolldrop()");

  puts("");
}

//------------------------------------------------------------------------------
/**
 */
void diag_bumpmaster_slaves(Bumpmaster const& bump) {
  puts("");
  //
  prt_tag(bump.t(), "bump, the Master");

  puts("");
  //
  prt_tag(bump.board().master(), "board's Master");
  prt_tag(bump.catalog().master(), "catalog's Master");
  prt_tag(bump.page().master(), "page's Master");
  prt_tag(bump.post().master(), "post's Master");
  prt_tag(bump.site().master(), "site's Master");
  prt_tag(bump.thread().master(), "thread's Master");
  prt_tag(bump.dolldrop().master(), "dolldrop's Master");

  puts("");
  // TEST:  (master == (slave's master))  equivalence:
  //
  cout << std::boolalpha;
  cout << "bump == board's Master :\t'"  //
       << (bump.t() == bump.board().master()) << "'\n";
  cout << "bump == catalog's Master :\t'"
       << (bump.t() == bump.catalog().master()) << "'\n";
  cout << "bump == page's Master :  \t'"  //
       << (bump.t() == bump.page().master()) << "'\n";
  cout << "bump == post's Master :  \t'"  //
       << (bump.t() == bump.post().master()) << "'\n";
  cout << "bump == site's Master :  \t'"  //
       << (bump.t() == bump.site().master()) << "'\n";
  cout << "bump == thread's Master :\t'"  //
       << (bump.t() == bump.thread().master()) << "'\n";
  cout << "bump == dolldrop's Master :\t'"  //
       << (bump.t() == bump.dolldrop().master()) << "'\n";
}

//    --=^=--

// "Everyone's talking about IT & the Internet, and how advanced it's getting."

// rw_bumpmaster_demo.v211225
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
